/*
 * (C) Copyright Parasoft Corporation 2018.  All rights reserved.
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF Parasoft
 * The copyright notice above does not evidence any
 * actual or intended publication of such source code.
 */



import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.Map;

import com.parasoft.api.Application;
import com.parasoft.api.ExtensionToolContext;

public class Example {

    public String decrypt(Object input, ExtensionToolContext context) throws NoSuchMethodException, SecurityException, IllegalAccessException, IllegalArgumentException, InvocationTargetException {
        byte[] rawBytes = getBytes(context);
        // TODO use decryption code
        return null;
    }

    private byte[] getBytes(ExtensionToolContext context) throws NoSuchMethodException, SecurityException, IllegalAccessException, IllegalArgumentException, InvocationTargetException {
        Application.showMessage("--- Loaded script! ---");
        Method getTopBatchContext = context.getClass().getMethod("getTopBatchContext");

        Object topBatch = getTopBatchContext.invoke(context);
        Application.showMessage("--- topBatch = " + topBatch.getClass().getName());

        Method getContextMap = topBatch.getClass().getMethod("getContextMap");
        Map<String, Object> map = (Map<String, Object>)getContextMap.invoke(topBatch);
        Object sbctx = map.get("webtool.tomcat.test.StubBatchContext");

        Application.showMessage("--- StubBatchContext = " + sbctx.getClass().getName());
        Method getIncomingMessage = sbctx.getClass().getMethod("getIncomingMessage");
        Object wrapper = getIncomingMessage.invoke(sbctx);
        Application.showMessage("--- ByteStringWrapper = " + wrapper);
        Method getBytes = wrapper.getClass().getMethod("getBytes");
        byte[] bytes = (byte[])getBytes.invoke(wrapper);
        Application.showMessage("--- bytes = " + bytes);
        return null;
    }
}
